# Etsy

使用 网页爬虫API，您可以抓取和解析各种类型的 **Etsy** 页面；下面是所有受支持爬虫及其相应 `source` 值的概述。

| 来源             | 说明                                                                                                                                                            | 专用解析器                                                                                                                          |
| -------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------ |
| `etsy_search`  | [**搜索页面**](https://app.gitbook.com/o/YFRJGnXcbhIMTe1cuCmz/s/zrXw45naRpCZ0Ku9AjY1/~/changes/816/scraper-apis/web-scraper-api/amazon-1/best-buy) 用于您选择的搜索词。     | 编号。                                                                                                                            |
| `etsy_product` | [**商品页面** ](https://app.gitbook.com/o/YFRJGnXcbhIMTe1cuCmz/s/zrXw45naRpCZ0Ku9AjY1/~/changes/816/scraper-apis/web-scraper-api/amazon-1/best-buy-1)用于您选择的商品 ID。 | 是的。                                                                                                                            |
| `etsy`         | 提交任何 Etsy [**URL**](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/targets/etsy/url) 您想要的。                            | 限制为 [Etsy 商品](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/targets/etsy/product) 页面。 |

## 快速开始

**创建您的 API 用户凭证**：在 [**Oxylabs 仪表板**](https://dashboard.oxylabs.io/en/registration) 注册试用或购买产品以创建您的 API 用户凭证（`USERNAME` 和 `PASSWORD`).

{% hint style="warning" %}
如果您需要为帐户创建多个 API 用户，请联系 [**客户支持**](mailto:support@oxylabs.io) 或使用我们的 24/7 在线聊天支持发送消息。
{% endhint %}

### 请求示例

{% tabs %}
{% tab title="cURL" %}

```bash
curl 'https://realtime.oxylabs.io/v1/queries' \
--user "USERNAME:PASSWORD" \
-H "Content-Type: application/json" \
-d '{
        "source": "etsy_product",
        "product_id": "1858266469",
        "parse": true
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# 构建负载。
payload = {
    'source': 'etsy_product',
    'product_id': '1858266469',
    'parse': True
}

# 获取响应。
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# 将美化后的响应打印到标准输出。
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "etsy_product",
    product_id: "1858266469",
    parse: true,
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'etsy_product',
    'product_id' => '1858266469',
    'parse' => true,
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
?>
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "etsy_product",
                product_id = "1858266469",
                parse = true
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.Encoding.ASCII.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source":       "etsy_product",
		"query":        "1858266469",
		"parse":        true,
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	request.Header.Set("Content-Type", "application/json")
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://realtime.oxylabs.io/v1/queries?source=etsy_product&product_id=1858266469&parse=true&access_token=12345abcde
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "etsy_product");
        jsonObject.put("product_id", "1858266469");
        jsonObject.put("parse", true);

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "etsy_product",
    "product_id": "1858266469",
    "parse": true
}
```

{% endtab %}
{% endtabs %}

<details>

<summary>输出示例</summary>

```json
{
    "results": [
        {
            "content": {
                "url": "https://www.etsy.com/listing/1858266469/freshwater-pearl-drop-earringsbridal",
                "price": 28,
                "title": "淡水珍珠垂坠耳环，婚礼珍珠耳环，18K 镀金垂式耳环，婚礼耳环，伴娘礼物，婚礼礼物，婚礼首饰",
                "images": [
                    "https://i.etsystatic.com/55594479/r/il/8c24e4/6566024892/il_75x75.6566024892_rdzf.jpg",
                    "https://v.etsystatic.com/video/upload/ar_1:1,c_fill,h_105,q_auto,w_105/WhatsApp_Video_2025-01-13_at_22.30.02_saxoj7.jpg",
                    "https://i.etsystatic.com/55594479/r/il/8784b7/6614140713/il_75x75.6614140713_mhgj.jpg",
                    "https://i.etsystatic.com/55594479/r/il/9febbb/6614140547/il_75x75.6614140547_6x1v.jpg",
                    "https://i.etsystatic.com/55594479/r/il/90ccaf/6566024810/il_75x75.6566024810_c7qt.jpg"
                ],
                "seller": {
                    "url": "https://www.etsy.com/shop/Divanjewelrygold?ref=shop-header-name&listing_id=1858266469&from_page=listing",
                    "title": "Divanjewelrygold",
                    "rating": 4.7059,
                    "best_seller": false,
                    "star_seller": false
                },
                "currency": "USD",
                "shipping": {
                    "from": ""
                },
                "avg_price": 33.33,
                "max_price": 36,
                "min_price": 28,
                "old_price": 35,
                "categories": [
                    {
                        "title": "主页"
                    },
                    {
                        "title": "Jewelry"
                    },
                    {
                        "title": "耳环"
                    },
                    {
                        "title": "垂坠式耳环"
                    }
                ],
                "customized": false,
                "product_id": "1858266469",
                "variation_count": 3,
                "parse_status_code": 12000
            },
            "created_at": "2025-03-04 12:25:23",
            "updated_at": "2025-03-04 12:25:37",
            "page": 1,
            "url": "https://www.etsy.com/listing/1858266469/freshwater-pearl-drop-earringsbridal",
            "job_id": "7302665462838490113",
            "is_render_forced": false,
            "status_code": 200,
            "parser_type": "etsy_product"
        }
    ]
}
```

</details>

我们在示例中使用同步 [**Realtime**](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/integration-methods/realtime) 集成方法。如果您想使用 [**Proxy Endpoint**](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/integration-methods/proxy-endpoint) 或异步 [**Push-Pull**](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/integration-methods/push-pull) 集成，请参阅 [**集成方法**](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/integration-methods) 部分。

可选地，您可以包含其他参数，例如`user_agent_type`, `parse`, `render` 以及更多可用于自定义您的爬取请求。阅读更多：

{% content-ref url="../features" %}
[features](https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/features)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/documentation/cn/zhua-qu-jie-jue-fang-an/web-scraper-api/targets/etsy.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
